import { Construct } from "constructs";
import { TerraformElement } from "./terraform-element";
import { TerraformGeneratorMetadata } from './terraform-resource';
export interface TerraformProviderConfig {
    readonly terraformResourceType: string;
    readonly terraformGeneratorMetadata?: TerraformGeneratorMetadata;
    readonly terraformProviderSource?: string;
}
export declare abstract class TerraformProvider extends TerraformElement {
    readonly terraformResourceType: string;
    readonly terraformGeneratorMetadata?: TerraformGeneratorMetadata;
    readonly terraformProviderSource?: string;
    alias?: string;
    constructor(scope: Construct, id: string, config: TerraformProviderConfig);
    get fqn(): string;
    get metaAttributes(): {
        [name: string]: any;
    };
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    /**
     * Adds this resource to the terraform JSON output.
     */
    toTerraform(): any;
}
